<?php
require_once( config_get_global( 'class_path' ) . 'MantisPlugin.class.php' );

class UserStatusColorsPlugin extends MantisPlugin {
  function register() {
    $this->name = plugin_lang_get( 'title' );
    $this->description = plugin_lang_get( 'description' );

    $this->version = '0.1';
    $this->requires = array(
      'MantisCore' => '1.2'
    );

    $this->author = 'Olivier Sannier';
    $this->contact  = 'obones@free.fr';
    $this->url    = 'http://www.obones.com';
  }

  function hooks() {
    return array(
      'EVENT_ACCOUNT_PREF_UPDATE_FORM' => 'account_pref_update_form',
			'EVENT_ACCOUNT_PREF_UPDATE' => 'account_pref_update',
    );
  }
  
  function account_pref_update_form($event_id, $user_id)
  {
    $status_colors = config_get( 'status_colors' );
    
    echo '<link rel="stylesheet" href="'.color_picker_include('js_color_picker_v2.css').'" media="screen">'."\n";
    echo '<script type="text/javascript" src="'.color_picker_include('color_functions.js').'"></script>'."\n";
    echo '<script type="text/javascript" src="'.color_picker_include('js_color_picker_v2.js').'"></script>'."\n";
    
    foreach ($status_colors as $status_name => $status_color)
    {
      $status_id = array_search($status_name, MantisEnum::getAssocArrayIndexedByValues(config_get( 'status_enum_string' )));
    
      $input_base_name = 'UserStatusColors_color_for'.$status_name;
  		echo '<tr ', helper_alternate_class(), '><td class="category">', sprintf(plugin_lang_get( 'color_for', 'UserStatusColors' ), get_enum_element('status', $status_id)),
  			'<input type="hidden" name="'.$input_base_name.'" value="1"/></td><td>',
  			'<input name="'.$input_base_name.'_value" id="'.$input_base_name.'_value" value="'.$status_color.'" style="float:left;"/>'.
        '<img style="float:left;padding-right:1px;padding-top:1px" src="'.color_picker_include('images/select_arrow.gif').'" onmouseover="this.src=\''.color_picker_include('images/select_arrow_over.gif').'\'" onmouseout="this.src=\''.color_picker_include('images/select_arrow.gif').'\'" onclick="showColorPicker(this,document.form_account_prefs.'.$input_base_name.'_value'.')">'.
  			'<input type="checkbox" name="'.$input_base_name.'_default" id="UserStatusColors_color_for'.$status_name.'_default" style="float: left; margin-left: 20px;"/>'.
        '<label for="'.$input_base_name.'_default"  style="float: left; margin-top: 2px;">'.plugin_lang_get( 'back_to_default', 'UserStatusColors' ).'</label>'.
        '</td>';
    }
    
  }
  
  function account_pref_update($event_id, $user_id)
  {
    $status_colors = config_get( 'status_colors' );
    $default_status_colors = config_get_global( 'status_colors' );
    
    foreach ($status_colors as $status_name => $status_color)
    {
      $input_base_name = 'UserStatusColors_color_for'.$status_name;
      
      $color_set = gpc_get_bool( $input_base_name, false );
      $color_back_to_default = gpc_get_bool( $input_base_name.'_default', false );
      $color_value = gpc_get_string( $input_base_name.'_value', '' );
      
      if ($color_back_to_default)
        $status_colors[$status_name] = $default_status_colors[$status_name];
      else if ($color_set)
        $status_colors[$status_name] = $color_value;
    }

    config_set('status_colors', $status_colors, $user_id);
  }
}

function color_picker_include($filename)
{
  return 'plugins/UserStatusColors/pages/color_picker/'.$filename;
}

